#ifndef MSP_GL_PIXELSTORE_H_
#define MSP_GL_PIXELSTORE_H_

#include <msp/graphics/image.h>
#include "bindable.h"

namespace Msp {
namespace GL {

class PixelStore: public BindableWithDefault<PixelStore>
{
private:
	enum ParameterMask
	{
		SIZE,
		ORIGIN,
		ALIGNMENT
	};

	unsigned row_length;
	unsigned image_height;
	unsigned skip_pixels;
	unsigned skip_rows;
	unsigned skip_images;
	unsigned alignment;

public:
	PixelStore();

	static PixelStore from_image(const Graphics::Image &);

private:
	void update_parameter(int) const;

public:
	void set_canvas_size(unsigned, unsigned);
	void set_origin(unsigned, unsigned, unsigned);
	void set_alignment(unsigned);

	void bind() const;
};

} // namespace GL
} // namespace Msp

#endif
