#ifndef MSP_GL_PRIMITIVETYPE_H_
#define MSP_GL_PRIMITIVETYPE_H_

#include <msp/strings/lexicalcast.h>
#include <msp/gl/extensions/msp_legacy_features.h>
#include "gl.h"

namespace Msp {
namespace GL {

enum PrimitiveType
{
	POINTS         = GL_POINTS,
	LINES          = GL_LINES,
	LINE_STRIP     = GL_LINE_STRIP,
	LINE_LOOP      = GL_LINE_LOOP,
	TRIANGLES      = GL_TRIANGLES,
	TRIANGLE_STRIP = GL_TRIANGLE_STRIP,
	TRIANGLE_FAN   = GL_TRIANGLE_FAN,
	QUADS          = GL_QUADS,
	QUAD_STRIP     = GL_QUAD_STRIP
};

void operator>>(const LexicalConverter &, PrimitiveType &);

void require_primitive_type(PrimitiveType);

} // namespace GL
} // namespace Msp

#endif
